<?php 

define ("DBG", 0);
include_once __DIR__ ."/include/myauroravar.php";
include_once __DIR__ ."/djgCalendar.php";
header('Content-type: text/html');

//include ("nightkp.php");
//date_default_timezone_set('America/Los_Angeles');
date_default_timezone_set('UTC');		//run on server, all use UTC

echo '<span style="color:#111;text-align:left;font-size:14px">';

define("F3DAY", "http://services.swpc.noaa.gov/text/3-day-forecast.txt");
define("G3DAY", "http://services.swpc.noaa.gov/text/3-day-geomag-forecast.txt");
//define("G3DAY", "text/3-day-geomag-forecast.txt");
define("F45DAY", "http://services.swpc.noaa.gov/text/45-day-ap-forecast.txt");
//define("F45DAY", "text/45-day-ap-forecast.txt");
define("F27DAY", "http://services.swpc.noaa.gov/text/27-day-outlook.txt");
//define("F27DAY", "text/27-day-outlook.txt");

$fileURLs=array(
	"F3"	=> F3DAY,
	"G3"	=> G3DAY,
	"F45"	=> F45DAY,
	"F27"	=> F27DAY,
);


/* **********************************************
		Entry function. Be care of global vars
   **********************************************/
$updated=kpmain();		//call by myaurora.php

echo '<br>Updated. <br>';

$imgac="kp/AuroraCalendar.png";
//echo '<img src="kp/AuroraCalendar.png"> <br>';		//test 
//echo '<img src=\"'. $imgac .'\"> <br>';

//echo date('T');		//x show PDT 

//make day 1, local time today 16:00
/* debug 
$row= "<br>\n";
echo $kp3.'<br>';

echo $row;

echo '<pre>'; //keep blank space.
printf("%s   %s  %s  %s<br>",substr($fcst[13],0,5), substr($fcst[13],12,7), substr($fcst[13],23,7), substr($fcst[13],34,7));
for ($i=14;$i<22;$i++){
	outrow($fcst[$i]);
} 
*/

echo '</pre>';
echo '</span>';
// global variables, use global if call other function which is globaling them !


/* moved to include/myauroravar.php
$kpStatus=[
	'kpfile' => __DIR__ ."/kp/kp72h.txt",
	'updateKp'	=> 0,
	'F3'	=>0,
	'G3'	=>0,	
	'F45'	=>0,
	'F27'	=>0,
	
];

$kp72h=[
	'idate' => '',
	'itime' => 0,
	'ftime' => 0,
	'source' => 'F3',
	'kp72h' => ' ',
	'kp72hf' => '',
	'kp72hg' => '',
	'kpmax3d' => '',
];

$kp45d=[
	'idate' => '',
	'itime' => 0,
	'ftime' => 0,
	'source' => 'F45',
	'kp45d' => '45d ',
	'kp45o' => 'original',	//org value
	'kp27o' => 'original'	
] ;
*/
/* ********************* Entry  **************************


*********************************************************/
//global
$txtFile=array();
$txtBuffer=array();		// save 4 files text

$kpAll=array(

);	// 

function kpmain(){
	global $kpStatus, $kp72h, $kp45d, $kps, $txtBuffer, $txtFile, $kpAll;

	$fld=__DIR__ ."/kp/kpLogs.txt";
	$kpStatus['updateKp']=1;
	$kpStatus['kpfile']=$fld;
	
	if(file_exists($fld)){
		$mtime=filemtime($fld);		//it's UTC, while windows show local time.
		if(time()<($mtime+15*60))	//every 15 minutes
			$kpStatus['updateKp']=0;	//	
			//debug return 0;				//not updated
	}
// find the 	
	$f3=$kpStatus['F3']=kpFileTime(F3DAY);
	$txtBuffer["F3"] =$txtFile;
	$kpAll["F3"]["text"]=$txtFile;
	$kpAll["F3"]["kp3day"] = get3daykp($txtBuffer["F3"] , $f3 );
	
	$g3=$kpStatus['G3']=kpFileTime(G3DAY);
	$txtBuffer["G3"] =$txtFile;
	$kpAll["G3"]["text"]=$txtFile;
	$kpAll["G3"]["kp3day"] = get3daykp($txtBuffer["G3"] , $g3 );

	$f45=$kpStatus['F45']=kpFileTime(F45DAY);
	$txtBuffer["F45"] =$txtFile;
	$kpAll["F45"]["text"]=$txtFile;
	$kpAll["F45"]["kp45day"] =getF45kp($txtBuffer["F45"]);		//forecast time long term
	
	$f27=$kpStatus['F27']=kpFileTime(F27DAY);
	$txtBuffer["F27"] =$txtFile;

	// if any file time newer than data time, do update 
	//do updating and plot	
	// 1. do F45DAY	
	$kp45d['itime']=$f45;
//	echo 'itime before: ' .$kp45d['itime'];
//		var_dump($kpAll);
	
	$kp45d['kp45d']=$kp45d['kp45o'];
	$kp45d['source']="F45";
/* // 2. If F27 is newer		//ignore
	*/
// 3. G3 vs F3 which is newer
	$kp72h['kp72hf'] ='';
	$kp72h['kp72hg'] ='';		//initialize
	$fg3=$f3;
	if ($f3 >$g3 ) $kfg="F3"; 
		else $kfg="G3"; 

	//$ftimeS=$kpAll[$kfg]["kp3day"]["fTime"];
	$kp72h['source'] =$kfg;
	$kp72h['itime']=$kpAll[$kfg]["kp3day"]["iTime"];
	$kp72h['ftime']=$kpAll[$kfg]["kp3day"]["fTime"];
	$kp72h['kp72h']=$kpAll[$kfg]["kp3day"]["cKph"];
	$kp72h['kpmax3d']=$kpAll[$kfg]["kp3day"]['kpmax3d'];
	
	if($fg3>$f45){		//renew recent 3 days
		renew3day();
		$kp45d['source']=$kfg;		// 3 day adjusted
	}
	$kp45d['itime']=$kpAll[$kfg]["kp3day"]["iTime"];
	
	$kp45d['idate']=gmdate("Y-m-d H:i:s " ,$kp45d['itime'] );
	$kp72h['idate']=gmdate("Y-m-d H:i:s " ,$kp72h['itime'] );
	
	$kps['kp72h']=$kp72h;
	$kps['kp45d']=$kp45d;
	$kps['kpStatus']=$kpStatus;
	//var_dump($kps);
// every 15minutse
	$fh=fopen ($fld, "w+");
	fprintf($fh, "Creat time: %s timestamp: %s\n", gmdate("Y-m-d H:i:s", time()) , time() );
	
	fprintf($fh, "3-day issue time  %s  timestamp: %s\n", $kp72h['idate'] ,$kp72h['itime']);
	fprintf($fh, "3-day forecast time  %s  timestamp: %s\n" ,gmdate("Y-m-d H:i:s " ,$kp72h['ftime']) ,$kp72h['ftime']);
	fprintf($fh, "%s\n", $kp72h['kp72h']);
	fprintf($fh, "3-day max: %s \n", $kp72h['kpmax3d']);
	fprintf($fh, "Source: %s \n", $kp72h['source']);
	
	fprintf($fh, "45-day issue time  %s  timestamp: %s\n", $kp45d['idate'] ,$kp45d['itime']);
	fprintf($fh, "45-day forecast time  %s  timestamp: %s\n" ,gmdate("Y-m-d H:i:s " ,$kp45d['ftime']) ,$kp45d['ftime']);
	fprintf($fh, "45-day original: %s \n" ,$kp45d['kp45o']);
	
	fprintf($fh, "45-day adjusted: %s\n", $kp45d['kp45d']);
	fprintf($fh, "Source: %s \n ", $kp45d['source']);
	fclose ($fh);
	$json = json_encode($kps, JSON_PRETTY_PRINT);
//	$jsn=json_decode($json, TRUE);
//	var_dump($jsn);
//	var_dump($kp72h);
	$fh=fopen(__DIR__ ."/kp/kpData.json", "w+");
	fprintf($fh, "%s", $json);
	fclose ($fh);
	$json = json_encode($kpAll, JSON_PRETTY_PRINT);
//	$jsn=json_decode($json, TRUE);
//	var_dump($jsn);
//	var_dump($kp72h);
	$fh=fopen(__DIR__ ."/kp/kpAll.json", "w+");
	fprintf($fh, "%s", $json);
	fclose ($fh);
	
	Calendar($kp72h, $kp45d);

//	var_dump($m3);

	
}

function renew3day(){
	global $kp45d, $kp72h;
//	echo "renew 3day...";
	$ftime45d=$kp45d['ftime'];		// >= itime
	$ftime72h=$kp72h['ftime'];		// >itime
	$kp45=$kp45d['kp45o'];		//45day original
	$kp3=$kp72h['kpmax3d'];		//float
	if($ftime72h==$ftime45d){
		$kp45=substr_replace($kp45, $kp3,  0 ,3);	//renew 3 days
//		echo "Hit 3!!!";
		}
	else if($ftime72h < $ftime45d){		// 1 day dif
//		echo "Hit 2!!! <br>";
		$kp2=substr($kp72h['kpmax3d'], 1, 2);
		$kp45=substr_replace($kp45, $kp2, 0 ,2);	//renew 2 days
	}
	else if($ftime72h > $ftime45d){		// ...... 45 day failed to renew, in weekend?
		$days=$ftime72h-$ftime45d;
		$days /=86400;
		$kp45=substr_replace($kp45, $kp3,  $days ,3);
//		echo "Hit!!! 45day failed to renew! <br>"; 
	}
	$kp45d['kp45d']=$kp45;		//updated
}


function getF27kp(){
//	echo "To do... <br>";
}


/*
	Functions
*/
function kpFileTime($fld){
	global $txtFile;
//	$fh=file_get_contents($fld, 0,null,0,100);
	$rows=file($fld, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	if($rows !== false) 
		$txtFile=$rows;
//		var_dump($fh);
	$itime=findIssueTime($rows);
//	echo $fld ." @" .date("Y-m-d H:i:s", $itime) ."<br>";
	return $itime;
}

function findIssueTime($rows){
	$l_issuetime=0;
	foreach ($rows as $key => $row){
		if(strpos($row, ":Issued:")!==false){			// same in F3 G3 and F45
			$seg=preg_split("/[\s,]+/",  $row);
			$s=$seg[1].'-'.$seg[2].'-'.$seg[3].' '.$seg[4].' '.$seg[5];
			$l_issuetime=strtotime($s);		
			break;
		} 
	}

	//echo date("Y-m-d H:i:s T", $l_issuetime);
	return $l_issuetime;
}

/*
NOAA web site is slow, detect issue time, update on time

3-day-forecast.txt do update 1:00 am/pm daily
save kp72h[] as kp72.txt file and check filemtime 

! 2023-4-2   Kp data changed from integer to decimal,  need to be round up with x.67
*/


function get3daykp($rows, $l_issuetime){
	global $kp72h;
//	$ff = getWebpage($file)['lines'] ;
//	if(DBG) var_dump ($ff);
	$fcst=array();
	$i=0;
	$i00=-1;
	foreach($rows as $row) {
		if($i00==-1) {
			if(strpos($row, "00-03UT")!==false) $i00=$i;
		}
		$fcst[]=$row;
		$i++;
	}

	$istime=getdate($l_issuetime);
//	var_dump($i00);
	//get forecast startdate, could be next year
	$days=preg_split("/[\s,]+/",  $fcst[$i00-1]/*, PREG_SPLIT_NO_EMPTY | PREG_SPLIT_DELIM_CAPTURE*/);
	//if(DBG) var_dump ($days);
//             Apr 04    Apr 05    Apr 06			//missing year
		$md=$days[1]." ".$days[2];
//		echo $md;
	//$fcdate=date_parse(substr($fcst[$i00-1],12,8));		//different format!!! 'month'/'day' vs 'mon'/mday
	$fcdate=date_parse($md);		//different format!!! 'month'/'day' vs 'mon'/mday

	$sttime=forecastYear($istime, $fcdate);			//3day forecast time
if(0){
	var_dump ($fcdate);
	
	echo ' 更新：'.date("Y/m/d H:i",$l_issuetime);
	echo ' for：'.date("Y/m/d H:i",$sttime);
}
// step 1. store all to $kp3=array[72],start from $stime

	$kph="";
	$max=0;
	// day 1
//	echo "<br> str: ";
	$kp3day=array();
	$kp3day["iTime"]=$l_issuetime;		//
	$kp3day["fTime"]=$sttime;		// forecast start time
	$hour =0;
	in_array ("00-03UT", $fcst );
	for ($d=0; $d<3; $d++){
		for ($i=0;$i<8;$i++){		// 8 seg a day, 3 days
			$seg=preg_split("/[\s,]+/",  $fcst[$i00+$i]);
			$c=$seg[$d+1];			//
			$v=floatval($c);
			$kp3day["fKp"][$hour ++]=$v;
			$k=strval(round($v));
//			echo "c=$c  k=$k";
			if($v>$max) $max=$v;	// max kp in a day, to adjust 45-day calendar
			$kph .=$k;				// 3 hours
			$kph .=$k;
			$kph .=$k;
		}
		$m3[$d] =$max;			
		$max=0;
	}
	$kp3day["cKph"]=$kph;
//	$kp72h['ftime'] =$sttime;
//	$kp72h['kp72h']=$kph;
//	$kp72h['kpmax3d']=strval(round($m3['0'])) .strval(round($m3['1'])) .strval(round($m3['2']));
	$kp3day['kpmax3d']=strval(round($m3['0'])) .strval(round($m3['1'])) .strval(round($m3['2']));

//	$kp72h[(string) $sttime] =$sttime;
//	echo $kp72h[(string) $sttime];
//	echo "<br> <br>";
//	var_dump ($kp3day);
	//return $sttime;
	return $kp3day;
}


/*
	Forecast date could be 1 day more or less than issue date
	$istime: issue time in date format
	$fcdate: forecast time in date format
return: int $fctime	
*/	
function forecastYear($istime, $fcdate){
	$fcdate['year']=$istime['year'];
	
	if($fcdate['month']>($istime['mon']+1) )		// Dec, last year
		$fcdate['year']--;
	else if($fcdate['month']<($istime['mon']) )		// Dec->Jan, next year
		$fcdate['year']++;
//	echo $istime['year'] .$istime['mon'] .$istime['mday'] .'<br>' ;
//	echo $fcdate['year'] .$fcdate['month'] .$fcdate['day'] .'<br>' ;
	$ftime=mktime(0,0,0, $fcdate['month'], $fcdate['day'], $fcdate['year'] );
	return $ftime;
}

/*
*/

/************************* 45 day Ap->Kp *****************************

 *********************************************************************/

function getF45kp($rows){
	global $kp45d, $txtBuffer;
	//        0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
//$kp=array(0,0,1,1,1,2,2,2,3,3,4, 4, 4, 4, 4, 5,5,5);
$kp=array(0,0,1,1,1,2,2,2,3,3,3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5,);
//	     0 1 2 3  4  5  6  7   8   9
$kpb=array(1,4,7,11,17,35,80,100,170,299);		// 7???
//echo '<pre>';	// <pre> keep blank space.
//echo '<div style="text-align:center;width:320px;height:130px;font-size:14px"> '; 
//echo date('Y-m-d H:i:s \n');
//printf ("%d \n", time());
//echo '<span style="color:red">这是红色的字</span>';
//	$file="http://services.swpc.noaa.gov/text/45-day-ap-forecast.txt";
	//$file="45-day-ap-forecast.txt";		//test data
	$fcst=array();
	$i=0;
	$i00=-1;
	foreach($rows as $row) {
		if($i00==-1) {
			if(strpos($row, "45-DAY AP FORECAST")!==false) $i00=$i;
		}
		$fcst[]=$row;
		$i++;
	}


	$datemark=array(23,44,55);	//use original date stamp
	//Get 30 days data to ap$[]
	$d=0;
	$i00 ++;		
	for ($i=0;$i<9;$i++){
		$seg=preg_split("/[\s,]+/",  $fcst[$i00+$i]);
		$datemark[$d]=strtotime( $seg[0]);
		$ap[$d++]=intval($seg[1]);
		$datemark[$d]=strtotime( $seg[2]);
		$ap[$d++]=intval($seg[3]);
		$datemark[$d]=strtotime( $seg[4]);
		$ap[$d++]=intval($seg[5]);
		$datemark[$d]=strtotime( $seg[6]);
		$ap[$d++]=intval($seg[7]);
		$datemark[$d]=strtotime( $seg[8]);
		$ap[$d++]=intval($seg[9]);
	}
//	var_dump ($datemark);
//	var_dump ($ap);
		
// convert ap to kp
	$kp='';
	$apx=9;
	for ($i=0;$i<45;$i++){		//45 days
		$k=$ap[$i];
		for($j=0;$j<9;$j++){
			if($k<$kpb[$j]) break;
		}
		$ap[$i]=$j;
		$kp .=(string) $j;
  }
	$kp45d['ftime']=$datemark[0];
	$kp45d['kp45o']=$kp;
	$kp45day['ftime']=$datemark[0];
	$kp45day["fKp"]=$ap;
	$kp45day["cKp"]=$kp;

//  echo "<br> 45 1st:   " .date("Y-m-d h:i:s" .$datemark[0]) ."<br>";
//  echo $kp;
//	var_dump($ap);
	//return $datemark[0];
	return $kp45day;
}

/*  ==============================================
Source:
https://stackoverflow.com/questions/21677579/server-configuration-by-allow-url-fopen-0-in
*/
function getWebpage( $url, $cookiesIn = '' ){
	$options = array(
		CURLOPT_RETURNTRANSFER => true,     // return web page
		CURLOPT_HEADER         => false,     //return headers or not in addition to content
		CURLOPT_FOLLOWLOCATION => true,     // follow redirects
		CURLOPT_ENCODING       => "",       // handle all encodings
		CURLOPT_AUTOREFERER    => true,     // set referer on redirect
		CURLOPT_CONNECTTIMEOUT => 120,      // timeout on connect
		CURLOPT_TIMEOUT        => 120,      // timeout on response
		CURLOPT_MAXREDIRS      => 10,       // stop after 10 redirects
		CURLINFO_HEADER_OUT    => true,
		CURLOPT_SSL_VERIFYPEER => false,     // Validate SSL Cert
		CURLOPT_HTTP_VERSION   => CURL_HTTP_VERSION_1_1,
		CURLOPT_COOKIE         => $cookiesIn
	);

	$ch      = curl_init( $url );
	curl_setopt_array( $ch, $options );
	$rough_content = curl_exec( $ch );
	$err     = curl_errno( $ch );
	$errmsg  = curl_error( $ch );
	$header  = curl_getinfo( $ch );
	curl_close( $ch );
	$header['errno']   = $err;
	$header['errmsg']  = $errmsg;

	if($options[CURLOPT_HEADER] ){
		$header_content = substr($rough_content, 0, $header['header_size']);
		//$body_content = substr($rough_content, $header['header_size']);
		$body_content = trim(str_replace($header_content, '', $rough_content));
		$pattern = "#Set-Cookie:\\s+(?<cookie>[^=]+=[^;]+)#m"; 
		preg_match_all($pattern, $header_content, $matches); 
		$cookiesOut = implode("; ", $matches['cookie']);

		$header['headers']  = $header_content;
		$header['content'] = $body_content;
		$header['cookies'] = $cookiesOut;
	}
	else	$header['content'] =$rough_content;
	$lines =explode("\n",$header['content']);
	$header['content'] =$rough_content;
	$header['lines'] =$lines;
	if($err) echo "<br>" .$url ." err msg: ". $errmsg;
//	var_dump($header);
	return $header;
}

?>
